﻿init python:
    class calendar_class:
        def __init__(self):
            self.play_day = 1
            self.minute = 23
            self.hour = 4
            self.week_day = 0
            self.month = 4
            self.year = 1439
            self.month_day = 16
            self.month_start = 6
            self.day = 1
            self.speed = 5
            self.week_days = [
                _("Sunday"), _("Monday"), _("Tuesday"),
                _("Wednesday"), _("Thursday"), 
                _("Friday"), _("Saturday")
                ]
            self.months = [
                [_("January"), 31],
                [_("February"), 28],
                [_("March"), 31],
                [_("April"), 30],
                [_("May"), 31],
                [_("June"), 30],
                [_("July"), 31],
                [_("August"), 31],
                [_("September"), 30],
                [_("October"), 31],
                [_("November"), 30],
                [_("December"), 31]
                ]
            self.seasons = [
                _("Spring"), _("Summer"), _("Autumn"), _("Winter")
            ]

        def tick(self, n = 1):
            for i in range(n):
                self.minute += 1
                if self.minute > 59:
                    self.minute = 0
                    self.hour_tick()

        def hour_tick(self, n=1):
            for i in range(n):
                self.hour += 1
                if self.hour > 23:
                    self.hour = 0
                    self.day += 1
                    self.play_day += 1
                    if self.week_day < 6:
                        self.week_day += 1
                    else:
                        self.week_day = 0
                    if self.month_day < self.months[self.month][1]:
                        self.month_day += 1
                    else:
                        self.month_day = 1
                        self.month_start = self.week_day
                        if self.month < 11:
                            self.month += 1
                        else:
                            self.month = 0
                            self.year += 1

        def speed_change(self, d = "reset"):
            if d == "up" and self.speed > 0.1:
                self.speed -= 0.1
            elif d == "down" and self.speed < 3.0:
                self.speed += 0.1
            elif d == "reset":
                self.speed = 2.0

default calendar = calendar_class()
# screen calendar_screen:
#     timer calendar.speed repeat True action Function(calendar.tick)

# init python:
#     config.overlay_screens.append("calendar_screen")